// This  skeleton file was automatically created by 
//            pkgmaker 0.1
//            Thursday, December 11 1997
// 
// Module: BoxIncidentFlux
// Author: Hassan Siddiqui
//
// Description: Abstract class for all Fluxtral shapes
// 
//  
// Modifications: See ChangeLog
// 
// $Id: BoxIncidentFlux.h,v 1.4 2002/02/12 08:32:19 gvacanti Exp $

#ifndef BOXINCIDENTFLUX_H
#define BOXINCIDENTFLUX_H

// General classes

#include <iostream>

// SAS-Specific classes

// General utility functions
#include "Tracer.h"

// Local classes
#include "IncidentFlux.h"

class BoxIncidentFlux: public IncidentFlux
{

public:

  BoxIncidentFlux(double energyLow, 
		  double energyHigh, 
		  double fluxLevel): 
    _energyLow(energyLow), 
    _energyHigh(energyHigh),
    _fluxLevel(fluxLevel)
    {
      PROC;
      ENDPROC;
    }

  double flux(double energy) const
    {
      PROC;
      cout << " flux : got energy " << energy << endl;
      cout << " returning " <<  (energy > _energyLow && energy < _energyHigh) ? _fluxLevel : 0.;
      RETURN (energy > _energyLow && energy < _energyHigh) ? _fluxLevel : 0.;
    };

private:

  BoxIncidentFlux();

  double _energyLow;
  double _energyHigh;
  double _fluxLevel;

};

#endif
